unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, MPlayer, StdCtrls, ComCtrls;

type
  TfrmMain = class(TForm)
    LifeImage: TImage;
    LifeTimer: TTimer;
    btnChange: TButton;
    Label1: TLabel;
    TrackBar: TTrackBar;
    btnStopStart: TButton;
    procedure LifeTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnChangeClick(Sender: TObject);
    procedure btnStopStartClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
Const
  xSize=40;
  ySize=25;
Type
  TLifeCells=array[0..xSize-1,0..ySize-1] of boolean;
var
  frmMain: TfrmMain;
  a:TLifeCells;

implementation

{$R *.DFM}

Procedure RandomCells;
  var
    i,j:integer;
    x:real;
begin
  x:=frmMain.TrackBar.Position/10;
  for i:=0 to xsize-1 do
  for j:=0 to ysize-1 do
    a[i,j]:=(random<x)
end;

Function NumberOfCells(x,y:integer):integer;
var i,j,xx,yy:integer;
begin
  result:=0;
  for i:=-1 to 1 do
  for j:=-1 to 1 do
    begin
      xx:=x+i; yy:=y+j;
      if xx=-1
        then
          xx:=xsize-1;
      if yy=-1
        then
          yy:=ysize-1;
      if xx=xsize
        then
          xx:=0;
      if yy=ysize
        then
          yy:=0;
      if a[xx,yy]
        then
          inc(result);
    end;
  if a[x,y]
    then
      dec(result)  
end;

Function NumberOfCellsMy(i,j:integer):integer;
var rr:integer;
begin
  rr:=0;
  if i>0
    then
      if a[i-1,j]
        then inc(rr);
   if j>0
    then
      if a[i,j-1]
        then inc(rr);
   if (i>0)and (j>0)
    then
      if a[i-1,j-1]
        then inc(rr);
   if i<xsize-1
     then
      if a[i+1,j]
        then inc(rr);
   if j<ysize-1
     then
      if a[i,j+1]
        then inc(rr);
   if (i<xsize-1)and(j<ysize-1)
     then
      if a[i+1,j+1]
        then inc(rr);
   if (i>0)and(j<ysize-1)
     then
      if a[i-1,j+1]
        then inc(rr);
   if (i<xsize-1)and(j>0)
     then
      if a[i+1,j-1]
        then inc(rr);
   result:=rr;     
end;

procedure DrawCells;
var
  i,j:integer;
begin
  with frmMain.LifeImage.Canvas do
    begin
      brush.Color:=clBlue;
      pen.Color:=brush.Color;
      rectangle(0,0,xsize*10,ysize*10);
      brush.Color:=clyellow;
      for i:=0 to xsize-1 do
      for j:=0 to ysize-1 do
        if a[i,j]
          then
            rectangle(i*10,j*10,i*10+10,j*10+10)
    end
end;

procedure TfrmMain.LifeTimerTimer(Sender: TObject);
var
  i,j:integer;
  b:TLifeCells;
begin
  for i:=0 to xsize-1 do
  for j:=0 to ysize-1 do
    begin
       case NumberOfCells(i,j) of
         2:b[i,j]:=a[i,j];
         3:b[i,j]:=true
         else
           b[i,j]:=false;
       end;
    end;
  a:=b;
  DrawCells;
  LifeImage.Repaint;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  randomize;
  LifeImage.Width:=xsize*10;
  LifeImage.Height:=ysize*10;
  RandomCells;
  DrawCells;
  LifeTimer.Enabled:=true;
end;

procedure TfrmMain.btnChangeClick(Sender: TObject);
begin
  RandomCells;
  DrawCells;
end;

procedure TfrmMain.btnStopStartClick(Sender: TObject);
begin
  LifeTimer.Enabled:=not(LifeTimer.Enabled)
end;

procedure TfrmMain.TrackBarChange(Sender: TObject);
begin
  RandomCells;
  DrawCells;
end;

end.
 